#ifndef __MAIN_H__
#define __MAIN_H__
#include <iostream>
#include <fstream>
#include <string>

#include "capd/capdlib.h"
#include "capd/covrel/TripleSet.h"
#include "capd/covrel/HSet3D.h"

#define CAPD_USER_NAMESPACE capd2
#define CAPD_DEFAULT_DIMENSION 2
        #include "capd/fdcapdlib.h"
#undef CAPD_USER_NAMESPACE
#undef CAPD_DEFAULT_DIMENSION

#define CAPD_USER_NAMESPACE capd3
#define CAPD_DEFAULT_DIMENSION 3
        #include "capd/fdcapdlib.h"
#undef CAPD_USER_NAMESPACE
#undef CAPD_DEFAULT_DIMENSION

typedef capd::covrel::GridSet<capd3::IMatrix> GridSet;

using namespace capd2;
using namespace std;
using capd::interval;
using capd::covrel::TripleSet;
using capd::covrel::HSet3D;
class PMap;

void initSets();
void writeReport(std::string s);
void checkConeCondition(PMap& pm, TripleSet &H, string message, int iterations);
bool checkCovering(PMap& pm, TripleSet& N, TripleSet& M, string message, int orientation, int iterations=1);
bool checkCovering(PMap& pm, TripleSet& N, HSet3D& M, string message, interval T);
bool checkCovering(PMap& pm, HSet3D& N, HSet3D& M, string message, interval T);

extern TripleSet N[5];
extern TripleSet H1, H2, G1, G2, M;
extern HSet3D H;


#endif
